using MoreLinq;
using System.Linq;
using UnityEngine.UI;

public class FactObjectUI : FactObject
{
    public Image[] Images;

    #region Unity Serialization
    protected override void _OnBeforeSerialize() { 
        if(Images == null)
            Images = GetComponents<Image>().ToArray();
    }

    protected override void _OnAfterDeserialize() { }
    #endregion Unity Serialization

    protected override void _Awake()
    {
        base._Awake();

        if(MaterialsToChange == null)
        {
            MaterialsToChange = new UnityEngine.Material[Images.Length];
            for (int i = 0; i < Images.Length; i++)
            {
                Images[i].material = new UnityEngine.Material(Images[i].material);
                MaterialsToChange[i] = Images[i].material;
            }
        }
    }

    protected override void _CustomReLabel()
    {
        switch (Fact) // for highly customized labels
        {
            case TestFact testFact:
                //FactText[0].text = testFact.Label;
                break;
            default:
                break;
        }
    }
}